
import { Observable, Subject } from 'rxjs';
import { AdapterEvent, GeneralEvent, MessageTransmissionManagerInterface, Transmission, TransmissionEvent, TransportEvent } from '../interface/interface';

export class MessageTransmissionManagerBase implements MessageTransmissionManagerInterface {
    private globalEvent!: Subject<GeneralEvent>
    private transportEvent!: Subject<TransportEvent>
    private adapterEvent!: Subject<AdapterEvent>
    protected eventObj = {
        globalEvent: this.globalEvent,
        transportEvent: this.transportEvent,
        adapterEvent: this.adapterEvent
    }

    constructor() {
        // logic here
    }

    public subscribe(): Observable<TransmissionEvent> {
        throw new Error(`Method not implemented`)
        /* Public interface to be used by 'client' to start transmitting and receiving. 
        It will listen to adapterEvent, if adapter is not associated with any existing clientID that are connected
        to the releveant transport service, than it will just pump in to the adapterEvent as ususal. But if it's a
        new lcient, then a new Transmission is instantiated particularly with that client. Then an adapteverEvent
        will also be attached to the transmission as well as toher relevant information so that a set of adapters
        can be instantiated to be used accordingly. */
    }

    protected instantiateTransmissionComponents(clientId: string): Transmission {
        throw new Error(`Method not implemented`)
        /* Subscribe to adapterEvent, adapter will give adapter with the relevant client information. 
        It will first check array of transmission clinetID, so if new clientId is detected then a new 
        transmission set will be instantiated. Then an observable instance for each transmission components
        will be attacked to each of the transmission componetns, so that the respective transmission 
        can handle more or less of the adapters instantiated by the adapter manager based on the new
        adapters or it ohter cases, terminating of adaptesr as well. */
    }
}